" --[[ scratchpad.lua
"
" creates a 'scratch' buffer which is ephemeral --
" it will disappear when vim closes, does not save to anything and does not
" appear in the buffer list. Useful for e.g. jotting down quick notes and thoughts.
"
" If called with bang, will replace the current buffer with the scratch
" window, otherwise opens a new split.
"
" The buffer, by default is set to the pandoc filetype.
" This can be changed by setting the `g:scratchpad_ft` variable or the `b:scratchpad_ft`
" variable to the intended filetype.
" ]]--

command! -nargs=? -bang ScratchPad :lua require("personal.scratchpad").create("<bang>","<args>")
